package FromDualMySQLgalera;

#
# Copyright (C) 2011 FromDual
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

use strict;
use warnings;
use FromDualMySQLagent ':stooges';

sub processGaleraInformation
{
  my $parameter_ref = shift;

  my %hGlobalVariables;
  my %hGlobalStatus;

  my @aGlobalVariablesToSend = (
);

  my @aGlobalStatusToSend = (
    'wsrep_replicated', 'wsrep_received'
  , 'wsrep_replicated_bytes', 'wsrep_received_bytes'
  , 'wsrep_local_commits', 'wsrep_local_cert_failures', 'wsrep_local_bf_aborts'
  , 'wsrep_flow_control_waits', 'wsrep_local_status'
  , 'wsrep_cluster_size', 'wsrep_cluster_status', 'wsrep_ready'
  );

  &FromDualMySQLagent::initValues(\%hGlobalVariables, \@aGlobalVariablesToSend);
  &FromDualMySQLagent::initValues(\%hGlobalStatus, \@aGlobalStatusToSend);

  my $dbh = &FromDualMySQLagent::getDatabaseConnection(\%$parameter_ref);

  if ( ! defined($dbh) ) {
    return -1;
  }

  &FromDualMySQLagent::getGlobalVariables(\%$parameter_ref, $dbh, \%hGlobalVariables);
  &FromDualMySQLagent::getGlobalStatus(\%$parameter_ref, $dbh, \%hGlobalStatus);

  &FromDualMySQLagent::releaseDatabaseConnection($dbh);

  # Do some post calculations

  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalVariables, \@aGlobalVariablesToSend, $$parameter_ref{'Domain'});
  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalStatus, \@aGlobalStatusToSend, $$parameter_ref{'Domain'});
}

1;
__END__
