package FromDualMySQLmyisam;

#
# Copyright (C) 2010 FromDual
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

use strict;
use warnings;
use FromDualMySQLagent ':stooges';
use POSIX qw(floor);

sub processMyisamInformation
{
  my $parameter_ref = shift;

  my %hGlobalVariables;
  my %hGlobalStatus;

  my @aGlobalVariablesToSend = (
    'key_buffer_size', 'key_buffer_blocks', 'key_cache_block_size'
  );

  my @aGlobalStatusToSend = (
    'Key_blocks_not_flushed', 'Key_blocks_unused'
  , 'Key_blocks_not_flushed', 'Key_blocks_unused', 'Key_blocks_used', 'Key_blocks_warm'
  , 'Key_read_requests', 'Key_reads', 'Key_write_requests', 'Key_writes'
  );

  &FromDualMySQLagent::initValues(\%hGlobalVariables, \@aGlobalVariablesToSend);
  &FromDualMySQLagent::initValues(\%hGlobalStatus, \@aGlobalStatusToSend);

  my $dbh = &FromDualMySQLagent::getDatabaseConnection(\%$parameter_ref);

  if ( ! defined($dbh) ) {
    return -1;
  }

  &FromDualMySQLagent::getGlobalVariables(\%$parameter_ref, $dbh, \%hGlobalVariables);
  &FromDualMySQLagent::getGlobalStatus(\%$parameter_ref, $dbh, \%hGlobalStatus);

  &FromDualMySQLagent::releaseDatabaseConnection($dbh);

  # Do some post calculations

  $hGlobalVariables{'key_buffer_blocks'} = $hGlobalVariables{'key_cache_block_size'} == 0 ? 0 : floor($hGlobalVariables{'key_buffer_size'} / $hGlobalVariables{'key_cache_block_size'});

  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalVariables, \@aGlobalVariablesToSend, $$parameter_ref{'Domain'});
  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalStatus, \@aGlobalStatusToSend, $$parameter_ref{'Domain'});
}

1;
__END__
